# signer-python-client
<!--------------------------------------------------------------------------------------------------------------------->  <h2>Authentication</h2>  <p>  In order to call this APIs, you will need an <strong>API key</strong>. Set the API key in the header <span class=\"code\">X-Api-Key</span>: </p>  <pre>X-Api-Key: your-app|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</pre>  <!---------------------------------------------------------------------------------------------------------------------> <br />  <h2>HTTP Codes</h2>  <p>  The APIs will return the following HTTP codes: </p>  <table>  <thead>   <tr>    <th>Code</th>    <th>Description</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">200 (OK)</strong></td>    <td>Request processed successfully. The response is different for each API, please refer to the operation's documentation</td>   </tr>   <tr>    <td><strong class=\"model-title\">400 (Bad Request)</strong></td>    <td>Syntax error. For instance, when a required field was not provided</td>   </tr>   <tr>    <td><strong class=\"model-title\">401 (Unauthorized)</strong></td>    <td>API key not provided or invalid</td>   </tr>   <tr>    <td><strong class=\"model-title\">403 (Forbidden)</strong></td>    <td>API key is valid, but the application has insufficient permissions to complete the requested operation</td>   </tr>   <tr>    <td><strong class=\"model-title\">422 (Unprocessable Entity)</strong></td>    <td>API error. The response is as defined in <a href=\"#model-ErrorModel\">ErrorModel</a></td>   </tr>  </tbody> </table>  <br />  <h3>Error Codes</h3>  <p>Some of the error codes returned in a 422 response are provided bellow*:</p>  <ul>  <li>CertificateNotFound</li>  <li>DocumentNotFound</li>  <li>FolderNotFound</li>  <li>CpfMismatch</li>  <li>CpfNotExpected</li>  <li>InvalidFlowAction</li>  <li>DocumentInvalidKey</li> </ul>  <p style=\"font-size: 0.9em\">  *The codes shown above are the main error codes. Nonetheless, this list is not comprehensive. New codes may be added anytime without previous warning. </p>  <!--------------------------------------------------------------------------------------------------------------------->  <br />  <h2>Webhooks</h2>  <p>  It is recomended to subscribe to Webhook events <strong>instead</strong> of polling APIs. To do so, enable webhooks and register an URL that will receive a POST request  whenever one of the events bellow occur. </p> <p>  All requests have the format described in <a href=\"#model-Webhooks.WebhookModel\">Webhooks.WebhookModel</a>.  The data field varies according to the webhook event type: </p>   <table>  <thead>   <tr>    <th>Event type</th>    <th>Description</th>    <th>Payload</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">DocumentSigned</strong></td>    <td>Triggered when a document is signed.</td>    <td><a href=\"#model-Webhooks.DocumentSignedModel\">Webhooks.DocumentSignedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentApproved</strong></td>    <td>Triggered when a document is approved.</td>    <td><a href=\"#model-Webhooks.DocumentApprovedModel\">Webhooks.DocumentApprovedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentRefused</strong></td>    <td>Triggered when a document is refused.</td>    <td><a href=\"#model-Webhooks.DocumentRefusedModel\">Webhooks.DocumentRefusedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentConcluded</strong></td>    <td>Triggered when the flow of a document is concluded.</td>    <td><a href=\"#model-Webhooks.DocumentConcludedModel\">Webhooks.DocumentConcludedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentCanceled</strong></td>    <td>Triggered when the document is canceled.</td>    <td><a href=\"#model-Webhooks.DocumentCanceledModel\">Webhooks.DocumentCanceledModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentExpired (v1.33.0)</strong></td>    <td>Triggered when the document is expired.</td>    <td><a href=\"#model-Webhooks.DocumentExpiredModel\">Webhooks.DocumentExpiredModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsCreated (v1.50.0)</strong></td>    <td>Triggered when one or more documents are created.</td>    <td><a href=\"#model-Webhooks.DocumentsCreatedModel\">Webhooks.DocumentsCreatedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsDeleted (v1.78.0)</strong></td>    <td>Triggered when one or more documents are deleted.</td>    <td><a href=\"#model-Webhooks.DocumentsDeletedModel\">Webhooks.DocumentsDeletedModel</a></td>   </tr>  </tbody> </table>  <p>  To register your application URL and enable Webhooks, access the integrations section in your <a href=\"/private/organizations\" target=\"_blank\">organization's details page</a>. </p> 

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.1.1
- Package version: 0.9.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import signer_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import signer_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import signer_client
from signer_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
body = signer_client.DocumentsMoveDocumentBatchRequest() # DocumentsMoveDocumentBatchRequest |  (optional)

try:
    # Moves a batch of documents to a folder.
    api_response = api_instance.api_documents_batch_folder_post(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_batch_folder_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
is_concluded = true # bool | (DEPRECATED) Please use \"Status\" parameter instead. Set to true to list concluded documents, false to list pending documents. (optional)
status = signer_client.DocumentFilterStatus() # DocumentFilterStatus | Filters by document status. Will override the \"IsConcluded\" property. (optional)
folder_id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str |  (optional)
folder_type = signer_client.FolderType() # FolderType |  (optional)
document_type = signer_client.DocumentTypes() # DocumentTypes |  (optional)
filter_by_document_type = true # bool | True if the documents should be filtered by type, use documentType to specify the document type.  If you want to filter only documents without a type, set this parameter to true and the documentType to null. (optional)
filter_by_pending_signature = true # bool | True if documents should be filtered only for those that have FlowAction of the type Signer or SignRule (optional)
query_type = signer_client.DocumentQueryTypes() # DocumentQueryTypes |  (optional)
participant_q = 'participant_q_example' # str | Query to filter by participant (optional)
participant_query_type = signer_client.ParticipantQueryTypes() # ParticipantQueryTypes |  (optional)
tags = 'tags_example' # str | Label/value pairs are separated by \"|\" (optional) and Tags separated by \",\". Only the first 10 pairs will be considered.  To search by tag value only, do not use the \"|\". (optional)
is_deleted = true # bool | Returns deleted documents that had the specified document status when deleted. (optional)
q = 'q_example' # str | Query to filter items. (optional)
limit = 56 # int | Number of items to return. (optional)
offset = 56 # int | The offset of the searched page (starting with 0). (optional)
order = signer_client.PaginationOrders() # PaginationOrders |  (optional)

try:
    # Retrieves the documents of the organization paginating the response.
    api_response = api_instance.api_documents_get(is_concluded=is_concluded, status=status, folder_id=folder_id, folder_type=folder_type, document_type=document_type, filter_by_document_type=filter_by_document_type, filter_by_pending_signature=filter_by_pending_signature, query_type=query_type, participant_q=participant_q, participant_query_type=participant_query_type, tags=tags, is_deleted=is_deleted, q=q, limit=limit, offset=offset, order=order)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_get: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | Document Id
body = signer_client.DocumentsActionUrlRequest() # DocumentsActionUrlRequest |  (optional)

try:
    # Retrieves an URL to redirect the user to the first pending action of the document.
    api_response = api_instance.api_documents_id_action_url_post(id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_action_url_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | 
body = signer_client.DocumentsCancelDocumentRequest() # DocumentsCancelDocumentRequest |  (optional)

try:
    # Cancels the document by providing a reason for the cancellation.
    api_instance.api_documents_id_cancellation_post(id, body=body)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_cancellation_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | Document id
type = signer_client.DocumentDownloadTypes() # DocumentDownloadTypes | The version type to download (optional)

try:
    # Downloads a specific version type of the document encoding the bytes in Base 64 format.
    api_response = api_instance.api_documents_id_content_b64_get(id, type=type)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_content_b64_get: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | Document id
type = signer_client.DocumentDownloadTypes() # DocumentDownloadTypes | The version type to download (optional)

try:
    # Downloads a specific version type of the document.
    api_instance.api_documents_id_content_get(id, type=type)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_content_get: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | Document id

try:
    # Deletes a specific document using it's id.
    api_instance.api_documents_id_delete(id)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_delete: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | 
body = signer_client.DocumentsEnvelopeAddVersionRequest() # DocumentsEnvelopeAddVersionRequest |  (optional)

try:
    # Adds a new version for an envelope.
    api_instance.api_documents_id_envelope_versions_post(id, body=body)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_envelope_versions_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | Id of the document
body = signer_client.DocumentsDocumentFlowEditRequest() # DocumentsDocumentFlowEditRequest |  (optional)

try:
    # Updates the document's flow.
    api_response = api_instance.api_documents_id_flow_post(id, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_flow_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | 
body = signer_client.DocumentsMoveDocumentRequest() # DocumentsMoveDocumentRequest |  (optional)

try:
    # Moves a document to a folder.
    api_instance.api_documents_id_folder_post(id, body=body)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_folder_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | Document id

try:
    # Retrieves the document's details.
    api_response = api_instance.api_documents_id_get(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_get: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | Id of the document
body = signer_client.DocumentsDocumentNotifiedEmailsEditRequest() # DocumentsDocumentNotifiedEmailsEditRequest |  (optional)

try:
    # Updates the document's notified emails
    api_instance.api_documents_id_notified_emails_put(id, body=body)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_notified_emails_put: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | 
body = signer_client.RefusalRefusalRequest() # RefusalRefusalRequest |  (optional)

try:
    # Refuses a document by providing a reason for the refusal.
    api_instance.api_documents_id_refusal_post(id, body=body)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_refusal_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | The Id of the document

try:
    # Retrieves the details of the document's signatures.
    api_response = api_instance.api_documents_id_signatures_details_get(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_signatures_details_get: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | Document id
type = signer_client.DocumentTicketType() # DocumentTicketType | The version type to download (optional)
preview = false # bool | If true, when downloading the document, the response will not include the name of the file (useful when embedding the document inside a web page for previewing) (optional) (default to false)

try:
    # Generates a URL (ticket) to download a specific version type of the document.
    api_response = api_instance.api_documents_id_ticket_get(id, type=type, preview=preview)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_ticket_get: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
id = '38400000-8cf0-11bd-b23e-10b96e4ef00d' # str | 
body = signer_client.DocumentsDocumentAddVersionRequest() # DocumentsDocumentAddVersionRequest |  (optional)

try:
    # Adds a new version for the document.
    api_instance.api_documents_id_versions_post(id, body=body)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_id_versions_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
key = 'key_example' # str | The verification code presented in the document

try:
    # Validates each signature in a document using the verification code
    api_response = api_instance.api_documents_keys_key_signatures_get(key)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_keys_key_signatures_get: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
body = signer_client.DocumentsCreateDocumentRequest() # DocumentsCreateDocumentRequest |  (optional)

try:
    # Creates one or multiple documents.
    api_response = api_instance.api_documents_post(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_post: %s\n" % e)

# Configure API key authorization: ApiKey
configuration = signer_client.Configuration()
configuration.api_key['X-Api-Key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Api-Key'] = 'Bearer'

# create an instance of the API class
api_instance = signer_client.DocumentsApi(signer_client.ApiClient(configuration))
body = signer_client.SignatureSignaturesInfoRequest() # SignatureSignaturesInfoRequest |  (optional)

try:
    # Validates each signature in the uploaded document
    api_response = api_instance.api_documents_validate_signatures_post(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DocumentsApi->api_documents_validate_signatures_post: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to */*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DocumentsApi* | [**api_documents_batch_folder_post**](docs/DocumentsApi.md#api_documents_batch_folder_post) | **POST** /api/documents/batch/folder | Moves a batch of documents to a folder.
*DocumentsApi* | [**api_documents_get**](docs/DocumentsApi.md#api_documents_get) | **GET** /api/documents | Retrieves the documents of the organization paginating the response.
*DocumentsApi* | [**api_documents_id_action_url_post**](docs/DocumentsApi.md#api_documents_id_action_url_post) | **POST** /api/documents/{id}/action-url | Retrieves an URL to redirect the user to the first pending action of the document.
*DocumentsApi* | [**api_documents_id_cancellation_post**](docs/DocumentsApi.md#api_documents_id_cancellation_post) | **POST** /api/documents/{id}/cancellation | Cancels the document by providing a reason for the cancellation.
*DocumentsApi* | [**api_documents_id_content_b64_get**](docs/DocumentsApi.md#api_documents_id_content_b64_get) | **GET** /api/documents/{id}/content-b64 | Downloads a specific version type of the document encoding the bytes in Base 64 format.
*DocumentsApi* | [**api_documents_id_content_get**](docs/DocumentsApi.md#api_documents_id_content_get) | **GET** /api/documents/{id}/content | Downloads a specific version type of the document.
*DocumentsApi* | [**api_documents_id_delete**](docs/DocumentsApi.md#api_documents_id_delete) | **DELETE** /api/documents/{id} | Deletes a specific document using it&#x27;s id.
*DocumentsApi* | [**api_documents_id_envelope_versions_post**](docs/DocumentsApi.md#api_documents_id_envelope_versions_post) | **POST** /api/documents/{id}/envelope/versions | Adds a new version for an envelope.
*DocumentsApi* | [**api_documents_id_flow_post**](docs/DocumentsApi.md#api_documents_id_flow_post) | **POST** /api/documents/{id}/flow | Updates the document&#x27;s flow.
*DocumentsApi* | [**api_documents_id_folder_post**](docs/DocumentsApi.md#api_documents_id_folder_post) | **POST** /api/documents/{id}/folder | Moves a document to a folder.
*DocumentsApi* | [**api_documents_id_get**](docs/DocumentsApi.md#api_documents_id_get) | **GET** /api/documents/{id} | Retrieves the document&#x27;s details.
*DocumentsApi* | [**api_documents_id_notified_emails_put**](docs/DocumentsApi.md#api_documents_id_notified_emails_put) | **PUT** /api/documents/{id}/notified-emails | Updates the document&#x27;s notified emails
*DocumentsApi* | [**api_documents_id_refusal_post**](docs/DocumentsApi.md#api_documents_id_refusal_post) | **POST** /api/documents/{id}/refusal | Refuses a document by providing a reason for the refusal.
*DocumentsApi* | [**api_documents_id_signatures_details_get**](docs/DocumentsApi.md#api_documents_id_signatures_details_get) | **GET** /api/documents/{id}/signatures-details | Retrieves the details of the document&#x27;s signatures.
*DocumentsApi* | [**api_documents_id_ticket_get**](docs/DocumentsApi.md#api_documents_id_ticket_get) | **GET** /api/documents/{id}/ticket | Generates a URL (ticket) to download a specific version type of the document.
*DocumentsApi* | [**api_documents_id_versions_post**](docs/DocumentsApi.md#api_documents_id_versions_post) | **POST** /api/documents/{id}/versions | Adds a new version for the document.
*DocumentsApi* | [**api_documents_keys_key_signatures_get**](docs/DocumentsApi.md#api_documents_keys_key_signatures_get) | **GET** /api/documents/keys/{key}/signatures | Validates each signature in a document using the verification code
*DocumentsApi* | [**api_documents_post**](docs/DocumentsApi.md#api_documents_post) | **POST** /api/documents | Creates one or multiple documents.
*DocumentsApi* | [**api_documents_validate_signatures_post**](docs/DocumentsApi.md#api_documents_validate_signatures_post) | **POST** /api/documents/validate-signatures | Validates each signature in the uploaded document
*FlowsApi* | [**api_document_flows_get**](docs/FlowsApi.md#api_document_flows_get) | **GET** /api/document-flows | List created flows.
*FlowsApi* | [**api_document_flows_id_delete**](docs/FlowsApi.md#api_document_flows_id_delete) | **DELETE** /api/document-flows/{id} | Deletes a flow.
*FlowsApi* | [**api_document_flows_id_get**](docs/FlowsApi.md#api_document_flows_id_get) | **GET** /api/document-flows/{id} | Retrieves flow details
*FlowsApi* | [**api_document_flows_id_put**](docs/FlowsApi.md#api_document_flows_id_put) | **PUT** /api/document-flows/{id} | Updates a flow.
*FlowsApi* | [**api_document_flows_post**](docs/FlowsApi.md#api_document_flows_post) | **POST** /api/document-flows | Creates a flow that can be used to create documents
*FoldersApi* | [**api_folders_get**](docs/FoldersApi.md#api_folders_get) | **GET** /api/folders | Retrieves all folders paginating the response
*FoldersApi* | [**api_folders_id_delete_post**](docs/FoldersApi.md#api_folders_id_delete_post) | **POST** /api/folders/{id}/delete | Deletes a folder.
*FoldersApi* | [**api_folders_id_get**](docs/FoldersApi.md#api_folders_id_get) | **GET** /api/folders/{id} | Retrieves the folder&#x27;s info.
*FoldersApi* | [**api_folders_post**](docs/FoldersApi.md#api_folders_post) | **POST** /api/folders | Creates a folder.
*MarksSessionsApi* | [**api_marks_sessions_documents_post**](docs/MarksSessionsApi.md#api_marks_sessions_documents_post) | **POST** /api/marks-sessions/documents | Creates a mark positioning session from a Document create request.
*MarksSessionsApi* | [**api_marks_sessions_id_get**](docs/MarksSessionsApi.md#api_marks_sessions_id_get) | **GET** /api/marks-sessions/{id} | Retrieves session information.
*MarksSessionsApi* | [**api_marks_sessions_post**](docs/MarksSessionsApi.md#api_marks_sessions_post) | **POST** /api/marks-sessions | Creates a mark positioning session by requiring only the necessary data.
*NotificationsApi* | [**api_notifications_flow_action_reminder_post**](docs/NotificationsApi.md#api_notifications_flow_action_reminder_post) | **POST** /api/notifications/flow-action-reminder | Sends a reminder email to the user of a flow action. (if the action is pending)
*NotificationsApi* | [**api_users_notify_pending_post**](docs/NotificationsApi.md#api_users_notify_pending_post) | **POST** /api/users/notify-pending | Sends a reminder email to the e-mails provided on request. Should be used after creating a batch of documents.
*OrganizationsApi* | [**api_organizations_users_get**](docs/OrganizationsApi.md#api_organizations_users_get) | **GET** /api/organizations/users | List organization users
*OrganizationsApi* | [**api_organizations_users_post**](docs/OrganizationsApi.md#api_organizations_users_post) | **POST** /api/organizations/users | Adds a user to the organization
*OrganizationsApi* | [**api_organizations_users_user_id_delete**](docs/OrganizationsApi.md#api_organizations_users_user_id_delete) | **DELETE** /api/organizations/users/{userId} | Deletes a user from organization
*UploadApi* | [**api_uploads_bytes_post**](docs/UploadApi.md#api_uploads_bytes_post) | **POST** /api/uploads/bytes | Uploads a file by sending a JSON request with the bytes in Base 64 format.
*UploadApi* | [**api_uploads_post**](docs/UploadApi.md#api_uploads_post) | **POST** /api/uploads | Uploads a file by sending a multipart/form-data request

## Documentation For Models

 - [ActionStatus](docs/ActionStatus.md)
 - [AgentTypes](docs/AgentTypes.md)
 - [AgentsAgentModel](docs/AgentsAgentModel.md)
 - [ApiUploadsBody](docs/ApiUploadsBody.md)
 - [ApplicationsApplicationDisplayModel](docs/ApplicationsApplicationDisplayModel.md)
 - [AttachmentsAttachmentModel](docs/AttachmentsAttachmentModel.md)
 - [AttachmentsAttachmentUploadModel](docs/AttachmentsAttachmentUploadModel.md)
 - [AttachmentsCreateAttachmentResult](docs/AttachmentsCreateAttachmentResult.md)
 - [AuthenticationTypes](docs/AuthenticationTypes.md)
 - [BatchItemResultModel](docs/BatchItemResultModel.md)
 - [BillingBillingInformationModel](docs/BillingBillingInformationModel.md)
 - [BillingCompanyBillingInformationModel](docs/BillingCompanyBillingInformationModel.md)
 - [BillingIndividualBillingInformationModel](docs/BillingIndividualBillingInformationModel.md)
 - [BillingInformationTypes](docs/BillingInformationTypes.md)
 - [CertificateHolderTypes](docs/CertificateHolderTypes.md)
 - [CertificateTypes](docs/CertificateTypes.md)
 - [CertificatesAttributeCertificateInfoModel](docs/CertificatesAttributeCertificateInfoModel.md)
 - [DeleteAction](docs/DeleteAction.md)
 - [DocumentDownloadTypes](docs/DocumentDownloadTypes.md)
 - [DocumentFilterStatus](docs/DocumentFilterStatus.md)
 - [DocumentFlowsDocumentFlowCreateRequest](docs/DocumentFlowsDocumentFlowCreateRequest.md)
 - [DocumentFlowsDocumentFlowData](docs/DocumentFlowsDocumentFlowData.md)
 - [DocumentFlowsDocumentFlowDetailsModel](docs/DocumentFlowsDocumentFlowDetailsModel.md)
 - [DocumentFlowsDocumentFlowModel](docs/DocumentFlowsDocumentFlowModel.md)
 - [DocumentMarkDocumentMarkPositionModel](docs/DocumentMarkDocumentMarkPositionModel.md)
 - [DocumentMarkFlowActionPositionModel](docs/DocumentMarkFlowActionPositionModel.md)
 - [DocumentMarkMarksSessionCreateRequest](docs/DocumentMarkMarksSessionCreateRequest.md)
 - [DocumentMarkMarksSessionCreateResponse](docs/DocumentMarkMarksSessionCreateResponse.md)
 - [DocumentMarkMarksSessionModel](docs/DocumentMarkMarksSessionModel.md)
 - [DocumentMarkPrePositionedDocumentMarkModel](docs/DocumentMarkPrePositionedDocumentMarkModel.md)
 - [DocumentMarkType](docs/DocumentMarkType.md)
 - [DocumentMarkUploadTicketModel](docs/DocumentMarkUploadTicketModel.md)
 - [DocumentQueryTypes](docs/DocumentQueryTypes.md)
 - [DocumentStatus](docs/DocumentStatus.md)
 - [DocumentTicketType](docs/DocumentTicketType.md)
 - [DocumentTypes](docs/DocumentTypes.md)
 - [DocumentsActionUrlRequest](docs/DocumentsActionUrlRequest.md)
 - [DocumentsActionUrlResponse](docs/DocumentsActionUrlResponse.md)
 - [DocumentsCancelDocumentRequest](docs/DocumentsCancelDocumentRequest.md)
 - [DocumentsCreateDocumentRequest](docs/DocumentsCreateDocumentRequest.md)
 - [DocumentsCreateDocumentResult](docs/DocumentsCreateDocumentResult.md)
 - [DocumentsCreatorModel](docs/DocumentsCreatorModel.md)
 - [DocumentsDocumentAddVersionRequest](docs/DocumentsDocumentAddVersionRequest.md)
 - [DocumentsDocumentAdditionalInfoData](docs/DocumentsDocumentAdditionalInfoData.md)
 - [DocumentsDocumentContentModel](docs/DocumentsDocumentContentModel.md)
 - [DocumentsDocumentFileModel](docs/DocumentsDocumentFileModel.md)
 - [DocumentsDocumentFlowEditRequest](docs/DocumentsDocumentFlowEditRequest.md)
 - [DocumentsDocumentListModel](docs/DocumentsDocumentListModel.md)
 - [DocumentsDocumentModel](docs/DocumentsDocumentModel.md)
 - [DocumentsDocumentNotifiedEmailsEditRequest](docs/DocumentsDocumentNotifiedEmailsEditRequest.md)
 - [DocumentsDocumentPermissionsModel](docs/DocumentsDocumentPermissionsModel.md)
 - [DocumentsDocumentSignaturesInfoModel](docs/DocumentsDocumentSignaturesInfoModel.md)
 - [DocumentsDocumentTagData](docs/DocumentsDocumentTagData.md)
 - [DocumentsDocumentTagModel](docs/DocumentsDocumentTagModel.md)
 - [DocumentsEnvelopeAddVersionRequest](docs/DocumentsEnvelopeAddVersionRequest.md)
 - [DocumentsFlowActionPendingModel](docs/DocumentsFlowActionPendingModel.md)
 - [DocumentsMoveDocumentBatchRequest](docs/DocumentsMoveDocumentBatchRequest.md)
 - [DocumentsMoveDocumentRequest](docs/DocumentsMoveDocumentRequest.md)
 - [DocumentsPrePositionedMarkModel](docs/DocumentsPrePositionedMarkModel.md)
 - [ErrorModel](docs/ErrorModel.md)
 - [FileModel](docs/FileModel.md)
 - [FileUploadModel](docs/FileUploadModel.md)
 - [FlowActionType](docs/FlowActionType.md)
 - [FlowActionsApprovalModel](docs/FlowActionsApprovalModel.md)
 - [FlowActionsDocumentFlowEditResponse](docs/FlowActionsDocumentFlowEditResponse.md)
 - [FlowActionsFlowActionCreateModel](docs/FlowActionsFlowActionCreateModel.md)
 - [FlowActionsFlowActionEditModel](docs/FlowActionsFlowActionEditModel.md)
 - [FlowActionsFlowActionModel](docs/FlowActionsFlowActionModel.md)
 - [FlowActionsPendingActionModel](docs/FlowActionsPendingActionModel.md)
 - [FlowActionsRectifiedParticipantModel](docs/FlowActionsRectifiedParticipantModel.md)
 - [FlowActionsSignRuleUserEditModel](docs/FlowActionsSignRuleUserEditModel.md)
 - [FlowActionsSignRuleUserModel](docs/FlowActionsSignRuleUserModel.md)
 - [FlowActionsSignatureModel](docs/FlowActionsSignatureModel.md)
 - [FlowActionsXadesOptionsModel](docs/FlowActionsXadesOptionsModel.md)
 - [FolderType](docs/FolderType.md)
 - [FoldersFolderCreateRequest](docs/FoldersFolderCreateRequest.md)
 - [FoldersFolderDeleteRequest](docs/FoldersFolderDeleteRequest.md)
 - [FoldersFolderInfoModel](docs/FoldersFolderInfoModel.md)
 - [FoldersFolderOrganizationModel](docs/FoldersFolderOrganizationModel.md)
 - [HealthDocumentsHealthDocumentData](docs/HealthDocumentsHealthDocumentData.md)
 - [HealthDocumentsHealthItemModel](docs/HealthDocumentsHealthItemModel.md)
 - [HealthDocumentsHealthProfessionalModel](docs/HealthDocumentsHealthProfessionalModel.md)
 - [InvoicesInvoiceTotalModel](docs/InvoicesInvoiceTotalModel.md)
 - [InvoicesUpdateInvoicePaymentStatusRequest](docs/InvoicesUpdateInvoicePaymentStatusRequest.md)
 - [NotarizationStatus](docs/NotarizationStatus.md)
 - [NotaryTypes](docs/NotaryTypes.md)
 - [NotificationsCreateFlowActionReminderRequest](docs/NotificationsCreateFlowActionReminderRequest.md)
 - [NotificationsEmailListNotificationRequest](docs/NotificationsEmailListNotificationRequest.md)
 - [ObserversObserverCreateModel](docs/ObserversObserverCreateModel.md)
 - [ObserversObserverEditModel](docs/ObserversObserverEditModel.md)
 - [ObserversObserverModel](docs/ObserversObserverModel.md)
 - [OrganizationType](docs/OrganizationType.md)
 - [OrganizationsAccessProfileModel](docs/OrganizationsAccessProfileModel.md)
 - [OrganizationsOrganizationInfoModel](docs/OrganizationsOrganizationInfoModel.md)
 - [OrganizationsOrganizationOwnerInfoModel](docs/OrganizationsOrganizationOwnerInfoModel.md)
 - [OrganizationsOrganizationUserModel](docs/OrganizationsOrganizationUserModel.md)
 - [OrganizationsOrganizationUserPostRequest](docs/OrganizationsOrganizationUserPostRequest.md)
 - [PaginatedSearchResponseDocumentFlowsDocumentFlowModel](docs/PaginatedSearchResponseDocumentFlowsDocumentFlowModel.md)
 - [PaginatedSearchResponseDocumentsDocumentListModel](docs/PaginatedSearchResponseDocumentsDocumentListModel.md)
 - [PaginatedSearchResponseFoldersFolderInfoModel](docs/PaginatedSearchResponseFoldersFolderInfoModel.md)
 - [PaginatedSearchResponseOrganizationsOrganizationUserModel](docs/PaginatedSearchResponseOrganizationsOrganizationUserModel.md)
 - [PaginationOrders](docs/PaginationOrders.md)
 - [ParticipantQueryTypes](docs/ParticipantQueryTypes.md)
 - [Probability](docs/Probability.md)
 - [RefusalRefusalModel](docs/RefusalRefusalModel.md)
 - [RefusalRefusalRequest](docs/RefusalRefusalRequest.md)
 - [SecurityContextsAuthenticationTypesModel](docs/SecurityContextsAuthenticationTypesModel.md)
 - [SecurityContextsSecurityContextSimpleModel](docs/SecurityContextsSecurityContextSimpleModel.md)
 - [SignatureDatavalidSelfieValidationResponse](docs/SignatureDatavalidSelfieValidationResponse.md)
 - [SignatureEvidencesModel](docs/SignatureEvidencesModel.md)
 - [SignatureGeolocationModel](docs/SignatureGeolocationModel.md)
 - [SignatureInitialsModes](docs/SignatureInitialsModes.md)
 - [SignatureLiveness3dAuthenticationModel](docs/SignatureLiveness3dAuthenticationModel.md)
 - [SignaturePixAuthenticationModel](docs/SignaturePixAuthenticationModel.md)
 - [SignatureSelfieModel](docs/SignatureSelfieModel.md)
 - [SignatureSignaturesInfoRequest](docs/SignatureSignaturesInfoRequest.md)
 - [SignatureTypes](docs/SignatureTypes.md)
 - [SignerModel](docs/SignerModel.md)
 - [TicketModel](docs/TicketModel.md)
 - [TimestampModel](docs/TimestampModel.md)
 - [TransactionPricingTypes](docs/TransactionPricingTypes.md)
 - [TransactionTypes](docs/TransactionTypes.md)
 - [TransactionsPriceRangeModel](docs/TransactionsPriceRangeModel.md)
 - [TransactionsTransactionPriceModel](docs/TransactionsTransactionPriceModel.md)
 - [UploadModel](docs/UploadModel.md)
 - [UploadsUploadBytesModel](docs/UploadsUploadBytesModel.md)
 - [UploadsUploadBytesRequest](docs/UploadsUploadBytesRequest.md)
 - [UsersParticipantUserModel](docs/UsersParticipantUserModel.md)
 - [ValidationItemModel](docs/ValidationItemModel.md)
 - [ValidationResultsModel](docs/ValidationResultsModel.md)
 - [WebhookTypes](docs/WebhookTypes.md)
 - [WebhooksDocumentApprovedModel](docs/WebhooksDocumentApprovedModel.md)
 - [WebhooksDocumentCanceledModel](docs/WebhooksDocumentCanceledModel.md)
 - [WebhooksDocumentConcludedModel](docs/WebhooksDocumentConcludedModel.md)
 - [WebhooksDocumentExpiredModel](docs/WebhooksDocumentExpiredModel.md)
 - [WebhooksDocumentInformationModel](docs/WebhooksDocumentInformationModel.md)
 - [WebhooksDocumentRefusedModel](docs/WebhooksDocumentRefusedModel.md)
 - [WebhooksDocumentSignedModel](docs/WebhooksDocumentSignedModel.md)
 - [WebhooksDocumentsCreatedModel](docs/WebhooksDocumentsCreatedModel.md)
 - [WebhooksDocumentsDeletedAction](docs/WebhooksDocumentsDeletedAction.md)
 - [WebhooksDocumentsDeletedModel](docs/WebhooksDocumentsDeletedModel.md)
 - [WebhooksInvoiceClosedModel](docs/WebhooksInvoiceClosedModel.md)
 - [WebhooksWebhookModel](docs/WebhooksWebhookModel.md)
 - [XadesElementIdentifierTypes](docs/XadesElementIdentifierTypes.md)
 - [XadesInsertionOptions](docs/XadesInsertionOptions.md)
 - [XadesSignatureTypes](docs/XadesSignatureTypes.md)
 - [XmlNamespaceModel](docs/XmlNamespaceModel.md)

## Documentation For Authorization


## ApiKey

- **Type**: API key
- **API key parameter name**: X-Api-Key
- **Location**: HTTP header


## Author


