# coding: utf-8

"""
    Dropsigner (HML)

    <!--------------------------------------------------------------------------------------------------------------------->  <h2>Authentication</h2>  <p>  In order to call this APIs, you will need an <strong>API key</strong>. Set the API key in the header <span class=\"code\">X-Api-Key</span>: </p>  <pre>X-Api-Key: your-app|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</pre>  <!---------------------------------------------------------------------------------------------------------------------> <br />  <h2>HTTP Codes</h2>  <p>  The APIs will return the following HTTP codes: </p>  <table>  <thead>   <tr>    <th>Code</th>    <th>Description</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">200 (OK)</strong></td>    <td>Request processed successfully. The response is different for each API, please refer to the operation's documentation</td>   </tr>   <tr>    <td><strong class=\"model-title\">400 (Bad Request)</strong></td>    <td>Syntax error. For instance, when a required field was not provided</td>   </tr>   <tr>    <td><strong class=\"model-title\">401 (Unauthorized)</strong></td>    <td>API key not provided or invalid</td>   </tr>   <tr>    <td><strong class=\"model-title\">403 (Forbidden)</strong></td>    <td>API key is valid, but the application has insufficient permissions to complete the requested operation</td>   </tr>   <tr>    <td><strong class=\"model-title\">422 (Unprocessable Entity)</strong></td>    <td>API error. The response is as defined in <a href=\"#model-ErrorModel\">ErrorModel</a></td>   </tr>  </tbody> </table>  <br />  <h3>Error Codes</h3>  <p>Some of the error codes returned in a 422 response are provided bellow*:</p>  <ul>  <li>CertificateNotFound</li>  <li>DocumentNotFound</li>  <li>FolderNotFound</li>  <li>CpfMismatch</li>  <li>CpfNotExpected</li>  <li>InvalidFlowAction</li>  <li>DocumentInvalidKey</li> </ul>  <p style=\"font-size: 0.9em\">  *The codes shown above are the main error codes. Nonetheless, this list is not comprehensive. New codes may be added anytime without previous warning. </p>  <!--------------------------------------------------------------------------------------------------------------------->  <br />  <h2>Webhooks</h2>  <p>  It is recomended to subscribe to Webhook events <strong>instead</strong> of polling APIs. To do so, enable webhooks and register an URL that will receive a POST request  whenever one of the events bellow occur. </p> <p>  All requests have the format described in <a href=\"#model-Webhooks.WebhookModel\">Webhooks.WebhookModel</a>.  The data field varies according to the webhook event type: </p>   <table>  <thead>   <tr>    <th>Event type</th>    <th>Description</th>    <th>Payload</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">DocumentSigned</strong></td>    <td>Triggered when a document is signed.</td>    <td><a href=\"#model-Webhooks.DocumentSignedModel\">Webhooks.DocumentSignedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentApproved</strong></td>    <td>Triggered when a document is approved.</td>    <td><a href=\"#model-Webhooks.DocumentApprovedModel\">Webhooks.DocumentApprovedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentRefused</strong></td>    <td>Triggered when a document is refused.</td>    <td><a href=\"#model-Webhooks.DocumentRefusedModel\">Webhooks.DocumentRefusedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentConcluded</strong></td>    <td>Triggered when the flow of a document is concluded.</td>    <td><a href=\"#model-Webhooks.DocumentConcludedModel\">Webhooks.DocumentConcludedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentCanceled</strong></td>    <td>Triggered when the document is canceled.</td>    <td><a href=\"#model-Webhooks.DocumentCanceledModel\">Webhooks.DocumentCanceledModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentExpired (v1.33.0)</strong></td>    <td>Triggered when the document is expired.</td>    <td><a href=\"#model-Webhooks.DocumentExpiredModel\">Webhooks.DocumentExpiredModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsCreated (v1.50.0)</strong></td>    <td>Triggered when one or more documents are created.</td>    <td><a href=\"#model-Webhooks.DocumentsCreatedModel\">Webhooks.DocumentsCreatedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsDeleted (v1.78.0)</strong></td>    <td>Triggered when one or more documents are deleted.</td>    <td><a href=\"#model-Webhooks.DocumentsDeletedModel\">Webhooks.DocumentsDeletedModel</a></td>   </tr>  </tbody> </table>  <p>  To register your application URL and enable Webhooks, access the integrations section in your <a href=\"/private/organizations\" target=\"_blank\">organization's details page</a>. </p>   # noqa: E501

    OpenAPI spec version: 2.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DocumentMarkMarksSessionCreateRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'files': 'list[UploadModel]',
        'is_envelope': 'bool',
        'flow_actions': 'list[DocumentMarkFlowActionPositionModel]',
        'signature_type': 'SignatureTypes'
    }

    attribute_map = {
        'files': 'files',
        'is_envelope': 'isEnvelope',
        'flow_actions': 'flowActions',
        'signature_type': 'signatureType'
    }

    def __init__(self, files=None, is_envelope=None, flow_actions=None, signature_type=None):  # noqa: E501
        """DocumentMarkMarksSessionCreateRequest - a model defined in Swagger"""  # noqa: E501
        self._files = None
        self._is_envelope = None
        self._flow_actions = None
        self._signature_type = None
        self.discriminator = None
        self.files = files
        if is_envelope is not None:
            self.is_envelope = is_envelope
        self.flow_actions = flow_actions
        if signature_type is not None:
            self.signature_type = signature_type

    @property
    def files(self):
        """Gets the files of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501


        :return: The files of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501
        :rtype: list[UploadModel]
        """
        return self._files

    @files.setter
    def files(self, files):
        """Sets the files of this DocumentMarkMarksSessionCreateRequest.


        :param files: The files of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501
        :type: list[UploadModel]
        """
        if files is None:
            raise ValueError("Invalid value for `files`, must not be `None`")  # noqa: E501

        self._files = files

    @property
    def is_envelope(self):
        """Gets the is_envelope of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501

        If true, groups all files into a single document (the envelope). All files must be in PDF format.  # noqa: E501

        :return: The is_envelope of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501
        :rtype: bool
        """
        return self._is_envelope

    @is_envelope.setter
    def is_envelope(self, is_envelope):
        """Sets the is_envelope of this DocumentMarkMarksSessionCreateRequest.

        If true, groups all files into a single document (the envelope). All files must be in PDF format.  # noqa: E501

        :param is_envelope: The is_envelope of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501
        :type: bool
        """

        self._is_envelope = is_envelope

    @property
    def flow_actions(self):
        """Gets the flow_actions of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501


        :return: The flow_actions of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501
        :rtype: list[DocumentMarkFlowActionPositionModel]
        """
        return self._flow_actions

    @flow_actions.setter
    def flow_actions(self, flow_actions):
        """Sets the flow_actions of this DocumentMarkMarksSessionCreateRequest.


        :param flow_actions: The flow_actions of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501
        :type: list[DocumentMarkFlowActionPositionModel]
        """
        if flow_actions is None:
            raise ValueError("Invalid value for `flow_actions`, must not be `None`")  # noqa: E501

        self._flow_actions = flow_actions

    @property
    def signature_type(self):
        """Gets the signature_type of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501


        :return: The signature_type of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501
        :rtype: SignatureTypes
        """
        return self._signature_type

    @signature_type.setter
    def signature_type(self, signature_type):
        """Sets the signature_type of this DocumentMarkMarksSessionCreateRequest.


        :param signature_type: The signature_type of this DocumentMarkMarksSessionCreateRequest.  # noqa: E501
        :type: SignatureTypes
        """

        self._signature_type = signature_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DocumentMarkMarksSessionCreateRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DocumentMarkMarksSessionCreateRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
