# coding: utf-8

"""
    Dropsigner (HML)

    <!--------------------------------------------------------------------------------------------------------------------->  <h2>Authentication</h2>  <p>  In order to call this APIs, you will need an <strong>API key</strong>. Set the API key in the header <span class=\"code\">X-Api-Key</span>: </p>  <pre>X-Api-Key: your-app|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</pre>  <!---------------------------------------------------------------------------------------------------------------------> <br />  <h2>HTTP Codes</h2>  <p>  The APIs will return the following HTTP codes: </p>  <table>  <thead>   <tr>    <th>Code</th>    <th>Description</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">200 (OK)</strong></td>    <td>Request processed successfully. The response is different for each API, please refer to the operation's documentation</td>   </tr>   <tr>    <td><strong class=\"model-title\">400 (Bad Request)</strong></td>    <td>Syntax error. For instance, when a required field was not provided</td>   </tr>   <tr>    <td><strong class=\"model-title\">401 (Unauthorized)</strong></td>    <td>API key not provided or invalid</td>   </tr>   <tr>    <td><strong class=\"model-title\">403 (Forbidden)</strong></td>    <td>API key is valid, but the application has insufficient permissions to complete the requested operation</td>   </tr>   <tr>    <td><strong class=\"model-title\">422 (Unprocessable Entity)</strong></td>    <td>API error. The response is as defined in <a href=\"#model-ErrorModel\">ErrorModel</a></td>   </tr>  </tbody> </table>  <br />  <h3>Error Codes</h3>  <p>Some of the error codes returned in a 422 response are provided bellow*:</p>  <ul>  <li>CertificateNotFound</li>  <li>DocumentNotFound</li>  <li>FolderNotFound</li>  <li>CpfMismatch</li>  <li>CpfNotExpected</li>  <li>InvalidFlowAction</li>  <li>DocumentInvalidKey</li> </ul>  <p style=\"font-size: 0.9em\">  *The codes shown above are the main error codes. Nonetheless, this list is not comprehensive. New codes may be added anytime without previous warning. </p>  <!--------------------------------------------------------------------------------------------------------------------->  <br />  <h2>Webhooks</h2>  <p>  It is recomended to subscribe to Webhook events <strong>instead</strong> of polling APIs. To do so, enable webhooks and register an URL that will receive a POST request  whenever one of the events bellow occur. </p> <p>  All requests have the format described in <a href=\"#model-Webhooks.WebhookModel\">Webhooks.WebhookModel</a>.  The data field varies according to the webhook event type: </p>   <table>  <thead>   <tr>    <th>Event type</th>    <th>Description</th>    <th>Payload</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">DocumentSigned</strong></td>    <td>Triggered when a document is signed.</td>    <td><a href=\"#model-Webhooks.DocumentSignedModel\">Webhooks.DocumentSignedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentApproved</strong></td>    <td>Triggered when a document is approved.</td>    <td><a href=\"#model-Webhooks.DocumentApprovedModel\">Webhooks.DocumentApprovedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentRefused</strong></td>    <td>Triggered when a document is refused.</td>    <td><a href=\"#model-Webhooks.DocumentRefusedModel\">Webhooks.DocumentRefusedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentConcluded</strong></td>    <td>Triggered when the flow of a document is concluded.</td>    <td><a href=\"#model-Webhooks.DocumentConcludedModel\">Webhooks.DocumentConcludedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentCanceled</strong></td>    <td>Triggered when the document is canceled.</td>    <td><a href=\"#model-Webhooks.DocumentCanceledModel\">Webhooks.DocumentCanceledModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentExpired (v1.33.0)</strong></td>    <td>Triggered when the document is expired.</td>    <td><a href=\"#model-Webhooks.DocumentExpiredModel\">Webhooks.DocumentExpiredModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsCreated (v1.50.0)</strong></td>    <td>Triggered when one or more documents are created.</td>    <td><a href=\"#model-Webhooks.DocumentsCreatedModel\">Webhooks.DocumentsCreatedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsDeleted (v1.78.0)</strong></td>    <td>Triggered when one or more documents are deleted.</td>    <td><a href=\"#model-Webhooks.DocumentsDeletedModel\">Webhooks.DocumentsDeletedModel</a></td>   </tr>  </tbody> </table>  <p>  To register your application URL and enable Webhooks, access the integrations section in your <a href=\"/private/organizations\" target=\"_blank\">organization's details page</a>. </p>   # noqa: E501

    OpenAPI spec version: 2.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DocumentsDocumentFlowEditRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'added_flow_actions': 'list[FlowActionsFlowActionCreateModel]',
        'edited_flow_actions': 'list[FlowActionsFlowActionEditModel]',
        'deleted_flow_action_ids': 'list[str]',
        'added_observers': 'list[ObserversObserverCreateModel]',
        'edited_observers': 'list[ObserversObserverEditModel]',
        'deleted_observer_ids': 'list[str]'
    }

    attribute_map = {
        'added_flow_actions': 'addedFlowActions',
        'edited_flow_actions': 'editedFlowActions',
        'deleted_flow_action_ids': 'deletedFlowActionIds',
        'added_observers': 'addedObservers',
        'edited_observers': 'editedObservers',
        'deleted_observer_ids': 'deletedObserverIds'
    }

    def __init__(self, added_flow_actions=None, edited_flow_actions=None, deleted_flow_action_ids=None, added_observers=None, edited_observers=None, deleted_observer_ids=None):  # noqa: E501
        """DocumentsDocumentFlowEditRequest - a model defined in Swagger"""  # noqa: E501
        self._added_flow_actions = None
        self._edited_flow_actions = None
        self._deleted_flow_action_ids = None
        self._added_observers = None
        self._edited_observers = None
        self._deleted_observer_ids = None
        self.discriminator = None
        if added_flow_actions is not None:
            self.added_flow_actions = added_flow_actions
        if edited_flow_actions is not None:
            self.edited_flow_actions = edited_flow_actions
        if deleted_flow_action_ids is not None:
            self.deleted_flow_action_ids = deleted_flow_action_ids
        if added_observers is not None:
            self.added_observers = added_observers
        if edited_observers is not None:
            self.edited_observers = edited_observers
        if deleted_observer_ids is not None:
            self.deleted_observer_ids = deleted_observer_ids

    @property
    def added_flow_actions(self):
        """Gets the added_flow_actions of this DocumentsDocumentFlowEditRequest.  # noqa: E501

        The actions to be added to the flow.  The FlowActionCreateModel.Step must be greater or equal to the current pending step.  # noqa: E501

        :return: The added_flow_actions of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :rtype: list[FlowActionsFlowActionCreateModel]
        """
        return self._added_flow_actions

    @added_flow_actions.setter
    def added_flow_actions(self, added_flow_actions):
        """Sets the added_flow_actions of this DocumentsDocumentFlowEditRequest.

        The actions to be added to the flow.  The FlowActionCreateModel.Step must be greater or equal to the current pending step.  # noqa: E501

        :param added_flow_actions: The added_flow_actions of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :type: list[FlowActionsFlowActionCreateModel]
        """

        self._added_flow_actions = added_flow_actions

    @property
    def edited_flow_actions(self):
        """Gets the edited_flow_actions of this DocumentsDocumentFlowEditRequest.  # noqa: E501

        The existing actions to be modified.  Flow actions that have already been completed or are partially completed cannot be edited.  # noqa: E501

        :return: The edited_flow_actions of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :rtype: list[FlowActionsFlowActionEditModel]
        """
        return self._edited_flow_actions

    @edited_flow_actions.setter
    def edited_flow_actions(self, edited_flow_actions):
        """Sets the edited_flow_actions of this DocumentsDocumentFlowEditRequest.

        The existing actions to be modified.  Flow actions that have already been completed or are partially completed cannot be edited.  # noqa: E501

        :param edited_flow_actions: The edited_flow_actions of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :type: list[FlowActionsFlowActionEditModel]
        """

        self._edited_flow_actions = edited_flow_actions

    @property
    def deleted_flow_action_ids(self):
        """Gets the deleted_flow_action_ids of this DocumentsDocumentFlowEditRequest.  # noqa: E501

        The Ids of flow actions to be deleted.  Flow actions that have already been completed or are partially completed cannot be deleted.  # noqa: E501

        :return: The deleted_flow_action_ids of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._deleted_flow_action_ids

    @deleted_flow_action_ids.setter
    def deleted_flow_action_ids(self, deleted_flow_action_ids):
        """Sets the deleted_flow_action_ids of this DocumentsDocumentFlowEditRequest.

        The Ids of flow actions to be deleted.  Flow actions that have already been completed or are partially completed cannot be deleted.  # noqa: E501

        :param deleted_flow_action_ids: The deleted_flow_action_ids of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :type: list[str]
        """

        self._deleted_flow_action_ids = deleted_flow_action_ids

    @property
    def added_observers(self):
        """Gets the added_observers of this DocumentsDocumentFlowEditRequest.  # noqa: E501

        The observers to be added to the document.  # noqa: E501

        :return: The added_observers of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :rtype: list[ObserversObserverCreateModel]
        """
        return self._added_observers

    @added_observers.setter
    def added_observers(self, added_observers):
        """Sets the added_observers of this DocumentsDocumentFlowEditRequest.

        The observers to be added to the document.  # noqa: E501

        :param added_observers: The added_observers of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :type: list[ObserversObserverCreateModel]
        """

        self._added_observers = added_observers

    @property
    def edited_observers(self):
        """Gets the edited_observers of this DocumentsDocumentFlowEditRequest.  # noqa: E501

        The existing observers to be modified.  # noqa: E501

        :return: The edited_observers of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :rtype: list[ObserversObserverEditModel]
        """
        return self._edited_observers

    @edited_observers.setter
    def edited_observers(self, edited_observers):
        """Sets the edited_observers of this DocumentsDocumentFlowEditRequest.

        The existing observers to be modified.  # noqa: E501

        :param edited_observers: The edited_observers of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :type: list[ObserversObserverEditModel]
        """

        self._edited_observers = edited_observers

    @property
    def deleted_observer_ids(self):
        """Gets the deleted_observer_ids of this DocumentsDocumentFlowEditRequest.  # noqa: E501

        The Ids of observers to be deleted.  # noqa: E501

        :return: The deleted_observer_ids of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._deleted_observer_ids

    @deleted_observer_ids.setter
    def deleted_observer_ids(self, deleted_observer_ids):
        """Sets the deleted_observer_ids of this DocumentsDocumentFlowEditRequest.

        The Ids of observers to be deleted.  # noqa: E501

        :param deleted_observer_ids: The deleted_observer_ids of this DocumentsDocumentFlowEditRequest.  # noqa: E501
        :type: list[str]
        """

        self._deleted_observer_ids = deleted_observer_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DocumentsDocumentFlowEditRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DocumentsDocumentFlowEditRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
