# coding: utf-8

"""
    Dropsigner (HML)

    <!--------------------------------------------------------------------------------------------------------------------->  <h2>Authentication</h2>  <p>  In order to call this APIs, you will need an <strong>API key</strong>. Set the API key in the header <span class=\"code\">X-Api-Key</span>: </p>  <pre>X-Api-Key: your-app|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</pre>  <!---------------------------------------------------------------------------------------------------------------------> <br />  <h2>HTTP Codes</h2>  <p>  The APIs will return the following HTTP codes: </p>  <table>  <thead>   <tr>    <th>Code</th>    <th>Description</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">200 (OK)</strong></td>    <td>Request processed successfully. The response is different for each API, please refer to the operation's documentation</td>   </tr>   <tr>    <td><strong class=\"model-title\">400 (Bad Request)</strong></td>    <td>Syntax error. For instance, when a required field was not provided</td>   </tr>   <tr>    <td><strong class=\"model-title\">401 (Unauthorized)</strong></td>    <td>API key not provided or invalid</td>   </tr>   <tr>    <td><strong class=\"model-title\">403 (Forbidden)</strong></td>    <td>API key is valid, but the application has insufficient permissions to complete the requested operation</td>   </tr>   <tr>    <td><strong class=\"model-title\">422 (Unprocessable Entity)</strong></td>    <td>API error. The response is as defined in <a href=\"#model-ErrorModel\">ErrorModel</a></td>   </tr>  </tbody> </table>  <br />  <h3>Error Codes</h3>  <p>Some of the error codes returned in a 422 response are provided bellow*:</p>  <ul>  <li>CertificateNotFound</li>  <li>DocumentNotFound</li>  <li>FolderNotFound</li>  <li>CpfMismatch</li>  <li>CpfNotExpected</li>  <li>InvalidFlowAction</li>  <li>DocumentInvalidKey</li> </ul>  <p style=\"font-size: 0.9em\">  *The codes shown above are the main error codes. Nonetheless, this list is not comprehensive. New codes may be added anytime without previous warning. </p>  <!--------------------------------------------------------------------------------------------------------------------->  <br />  <h2>Webhooks</h2>  <p>  It is recomended to subscribe to Webhook events <strong>instead</strong> of polling APIs. To do so, enable webhooks and register an URL that will receive a POST request  whenever one of the events bellow occur. </p> <p>  All requests have the format described in <a href=\"#model-Webhooks.WebhookModel\">Webhooks.WebhookModel</a>.  The data field varies according to the webhook event type: </p>   <table>  <thead>   <tr>    <th>Event type</th>    <th>Description</th>    <th>Payload</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">DocumentSigned</strong></td>    <td>Triggered when a document is signed.</td>    <td><a href=\"#model-Webhooks.DocumentSignedModel\">Webhooks.DocumentSignedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentApproved</strong></td>    <td>Triggered when a document is approved.</td>    <td><a href=\"#model-Webhooks.DocumentApprovedModel\">Webhooks.DocumentApprovedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentRefused</strong></td>    <td>Triggered when a document is refused.</td>    <td><a href=\"#model-Webhooks.DocumentRefusedModel\">Webhooks.DocumentRefusedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentConcluded</strong></td>    <td>Triggered when the flow of a document is concluded.</td>    <td><a href=\"#model-Webhooks.DocumentConcludedModel\">Webhooks.DocumentConcludedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentCanceled</strong></td>    <td>Triggered when the document is canceled.</td>    <td><a href=\"#model-Webhooks.DocumentCanceledModel\">Webhooks.DocumentCanceledModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentExpired (v1.33.0)</strong></td>    <td>Triggered when the document is expired.</td>    <td><a href=\"#model-Webhooks.DocumentExpiredModel\">Webhooks.DocumentExpiredModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsCreated (v1.50.0)</strong></td>    <td>Triggered when one or more documents are created.</td>    <td><a href=\"#model-Webhooks.DocumentsCreatedModel\">Webhooks.DocumentsCreatedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsDeleted (v1.78.0)</strong></td>    <td>Triggered when one or more documents are deleted.</td>    <td><a href=\"#model-Webhooks.DocumentsDeletedModel\">Webhooks.DocumentsDeletedModel</a></td>   </tr>  </tbody> </table>  <p>  To register your application URL and enable Webhooks, access the integrations section in your <a href=\"/private/organizations\" target=\"_blank\">organization's details page</a>. </p>   # noqa: E501

    OpenAPI spec version: 2.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SecurityContextsSecurityContextSimpleModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'english_name': 'str',
        'portuguese_name': 'str',
        'spanish_name': 'str',
        'allow_digital_signature': 'bool',
        'allowed_electronic_types': 'SecurityContextsAuthenticationTypesModel',
        'require_liveness_on_selfie_authentication': 'bool',
        'require_liveness_on_datavalid_authentication': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'english_name': 'englishName',
        'portuguese_name': 'portugueseName',
        'spanish_name': 'spanishName',
        'allow_digital_signature': 'allowDigitalSignature',
        'allowed_electronic_types': 'allowedElectronicTypes',
        'require_liveness_on_selfie_authentication': 'requireLivenessOnSelfieAuthentication',
        'require_liveness_on_datavalid_authentication': 'requireLivenessOnDatavalidAuthentication'
    }

    def __init__(self, id=None, name=None, english_name=None, portuguese_name=None, spanish_name=None, allow_digital_signature=None, allowed_electronic_types=None, require_liveness_on_selfie_authentication=None, require_liveness_on_datavalid_authentication=None):  # noqa: E501
        """SecurityContextsSecurityContextSimpleModel - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._english_name = None
        self._portuguese_name = None
        self._spanish_name = None
        self._allow_digital_signature = None
        self._allowed_electronic_types = None
        self._require_liveness_on_selfie_authentication = None
        self._require_liveness_on_datavalid_authentication = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if english_name is not None:
            self.english_name = english_name
        if portuguese_name is not None:
            self.portuguese_name = portuguese_name
        if spanish_name is not None:
            self.spanish_name = spanish_name
        if allow_digital_signature is not None:
            self.allow_digital_signature = allow_digital_signature
        if allowed_electronic_types is not None:
            self.allowed_electronic_types = allowed_electronic_types
        if require_liveness_on_selfie_authentication is not None:
            self.require_liveness_on_selfie_authentication = require_liveness_on_selfie_authentication
        if require_liveness_on_datavalid_authentication is not None:
            self.require_liveness_on_datavalid_authentication = require_liveness_on_datavalid_authentication

    @property
    def id(self):
        """Gets the id of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The id of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SecurityContextsSecurityContextSimpleModel.


        :param id: The id of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SecurityContextsSecurityContextSimpleModel.


        :param name: The name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def english_name(self):
        """Gets the english_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The english_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: str
        """
        return self._english_name

    @english_name.setter
    def english_name(self, english_name):
        """Sets the english_name of this SecurityContextsSecurityContextSimpleModel.


        :param english_name: The english_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: str
        """

        self._english_name = english_name

    @property
    def portuguese_name(self):
        """Gets the portuguese_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The portuguese_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: str
        """
        return self._portuguese_name

    @portuguese_name.setter
    def portuguese_name(self, portuguese_name):
        """Sets the portuguese_name of this SecurityContextsSecurityContextSimpleModel.


        :param portuguese_name: The portuguese_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: str
        """

        self._portuguese_name = portuguese_name

    @property
    def spanish_name(self):
        """Gets the spanish_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The spanish_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: str
        """
        return self._spanish_name

    @spanish_name.setter
    def spanish_name(self, spanish_name):
        """Sets the spanish_name of this SecurityContextsSecurityContextSimpleModel.


        :param spanish_name: The spanish_name of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: str
        """

        self._spanish_name = spanish_name

    @property
    def allow_digital_signature(self):
        """Gets the allow_digital_signature of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The allow_digital_signature of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: bool
        """
        return self._allow_digital_signature

    @allow_digital_signature.setter
    def allow_digital_signature(self, allow_digital_signature):
        """Sets the allow_digital_signature of this SecurityContextsSecurityContextSimpleModel.


        :param allow_digital_signature: The allow_digital_signature of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: bool
        """

        self._allow_digital_signature = allow_digital_signature

    @property
    def allowed_electronic_types(self):
        """Gets the allowed_electronic_types of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The allowed_electronic_types of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: SecurityContextsAuthenticationTypesModel
        """
        return self._allowed_electronic_types

    @allowed_electronic_types.setter
    def allowed_electronic_types(self, allowed_electronic_types):
        """Sets the allowed_electronic_types of this SecurityContextsSecurityContextSimpleModel.


        :param allowed_electronic_types: The allowed_electronic_types of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: SecurityContextsAuthenticationTypesModel
        """

        self._allowed_electronic_types = allowed_electronic_types

    @property
    def require_liveness_on_selfie_authentication(self):
        """Gets the require_liveness_on_selfie_authentication of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The require_liveness_on_selfie_authentication of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: bool
        """
        return self._require_liveness_on_selfie_authentication

    @require_liveness_on_selfie_authentication.setter
    def require_liveness_on_selfie_authentication(self, require_liveness_on_selfie_authentication):
        """Sets the require_liveness_on_selfie_authentication of this SecurityContextsSecurityContextSimpleModel.


        :param require_liveness_on_selfie_authentication: The require_liveness_on_selfie_authentication of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: bool
        """

        self._require_liveness_on_selfie_authentication = require_liveness_on_selfie_authentication

    @property
    def require_liveness_on_datavalid_authentication(self):
        """Gets the require_liveness_on_datavalid_authentication of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501


        :return: The require_liveness_on_datavalid_authentication of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :rtype: bool
        """
        return self._require_liveness_on_datavalid_authentication

    @require_liveness_on_datavalid_authentication.setter
    def require_liveness_on_datavalid_authentication(self, require_liveness_on_datavalid_authentication):
        """Sets the require_liveness_on_datavalid_authentication of this SecurityContextsSecurityContextSimpleModel.


        :param require_liveness_on_datavalid_authentication: The require_liveness_on_datavalid_authentication of this SecurityContextsSecurityContextSimpleModel.  # noqa: E501
        :type: bool
        """

        self._require_liveness_on_datavalid_authentication = require_liveness_on_datavalid_authentication

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SecurityContextsSecurityContextSimpleModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SecurityContextsSecurityContextSimpleModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
