# coding: utf-8

"""
    Dropsigner (HML)

    <!--------------------------------------------------------------------------------------------------------------------->  <h2>Authentication</h2>  <p>  In order to call this APIs, you will need an <strong>API key</strong>. Set the API key in the header <span class=\"code\">X-Api-Key</span>: </p>  <pre>X-Api-Key: your-app|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</pre>  <!---------------------------------------------------------------------------------------------------------------------> <br />  <h2>HTTP Codes</h2>  <p>  The APIs will return the following HTTP codes: </p>  <table>  <thead>   <tr>    <th>Code</th>    <th>Description</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">200 (OK)</strong></td>    <td>Request processed successfully. The response is different for each API, please refer to the operation's documentation</td>   </tr>   <tr>    <td><strong class=\"model-title\">400 (Bad Request)</strong></td>    <td>Syntax error. For instance, when a required field was not provided</td>   </tr>   <tr>    <td><strong class=\"model-title\">401 (Unauthorized)</strong></td>    <td>API key not provided or invalid</td>   </tr>   <tr>    <td><strong class=\"model-title\">403 (Forbidden)</strong></td>    <td>API key is valid, but the application has insufficient permissions to complete the requested operation</td>   </tr>   <tr>    <td><strong class=\"model-title\">422 (Unprocessable Entity)</strong></td>    <td>API error. The response is as defined in <a href=\"#model-ErrorModel\">ErrorModel</a></td>   </tr>  </tbody> </table>  <br />  <h3>Error Codes</h3>  <p>Some of the error codes returned in a 422 response are provided bellow*:</p>  <ul>  <li>CertificateNotFound</li>  <li>DocumentNotFound</li>  <li>FolderNotFound</li>  <li>CpfMismatch</li>  <li>CpfNotExpected</li>  <li>InvalidFlowAction</li>  <li>DocumentInvalidKey</li> </ul>  <p style=\"font-size: 0.9em\">  *The codes shown above are the main error codes. Nonetheless, this list is not comprehensive. New codes may be added anytime without previous warning. </p>  <!--------------------------------------------------------------------------------------------------------------------->  <br />  <h2>Webhooks</h2>  <p>  It is recomended to subscribe to Webhook events <strong>instead</strong> of polling APIs. To do so, enable webhooks and register an URL that will receive a POST request  whenever one of the events bellow occur. </p> <p>  All requests have the format described in <a href=\"#model-Webhooks.WebhookModel\">Webhooks.WebhookModel</a>.  The data field varies according to the webhook event type: </p>   <table>  <thead>   <tr>    <th>Event type</th>    <th>Description</th>    <th>Payload</th>   </tr>  </thead>  <tbody>   <tr>    <td><strong class=\"model-title\">DocumentSigned</strong></td>    <td>Triggered when a document is signed.</td>    <td><a href=\"#model-Webhooks.DocumentSignedModel\">Webhooks.DocumentSignedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentApproved</strong></td>    <td>Triggered when a document is approved.</td>    <td><a href=\"#model-Webhooks.DocumentApprovedModel\">Webhooks.DocumentApprovedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentRefused</strong></td>    <td>Triggered when a document is refused.</td>    <td><a href=\"#model-Webhooks.DocumentRefusedModel\">Webhooks.DocumentRefusedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentConcluded</strong></td>    <td>Triggered when the flow of a document is concluded.</td>    <td><a href=\"#model-Webhooks.DocumentConcludedModel\">Webhooks.DocumentConcludedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentCanceled</strong></td>    <td>Triggered when the document is canceled.</td>    <td><a href=\"#model-Webhooks.DocumentCanceledModel\">Webhooks.DocumentCanceledModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentExpired (v1.33.0)</strong></td>    <td>Triggered when the document is expired.</td>    <td><a href=\"#model-Webhooks.DocumentExpiredModel\">Webhooks.DocumentExpiredModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsCreated (v1.50.0)</strong></td>    <td>Triggered when one or more documents are created.</td>    <td><a href=\"#model-Webhooks.DocumentsCreatedModel\">Webhooks.DocumentsCreatedModel</a></td>   </tr>   <tr>    <td><strong class=\"model-title\">DocumentsDeleted (v1.78.0)</strong></td>    <td>Triggered when one or more documents are deleted.</td>    <td><a href=\"#model-Webhooks.DocumentsDeletedModel\">Webhooks.DocumentsDeletedModel</a></td>   </tr>  </tbody> </table>  <p>  To register your application URL and enable Webhooks, access the integrations section in your <a href=\"/private/organizations\" target=\"_blank\">organization's details page</a>. </p>   # noqa: E501

    OpenAPI spec version: 2.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from setuptools import setup, find_packages  # noqa: H301

NAME = "signer-python-client"
VERSION = "0.9.0"
# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools

REQUIRES = ["urllib3 >= 1.15", "six >= 1.10", "certifi", "python-dateutil"]

setup(
    name=NAME,
    version=VERSION,
    description="Dropsigner (HML)",
    author_email="",
    url="https://github.com/lacunasoftware/signer-python-client",
    keywords=["Swagger", "Dropsigner (HML)"],
    install_requires=REQUIRES,
    packages=find_packages(),
    include_package_data=True,
    long_description="""\
    &lt;!---------------------------------------------------------------------------------------------------------------------&gt;  &lt;h2&gt;Authentication&lt;/h2&gt;  &lt;p&gt;  In order to call this APIs, you will need an &lt;strong&gt;API key&lt;/strong&gt;. Set the API key in the header &lt;span class&#x3D;\&quot;code\&quot;&gt;X-Api-Key&lt;/span&gt;: &lt;/p&gt;  &lt;pre&gt;X-Api-Key: your-app|xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx&lt;/pre&gt;  &lt;!---------------------------------------------------------------------------------------------------------------------&gt; &lt;br /&gt;  &lt;h2&gt;HTTP Codes&lt;/h2&gt;  &lt;p&gt;  The APIs will return the following HTTP codes: &lt;/p&gt;  &lt;table&gt;  &lt;thead&gt;   &lt;tr&gt;    &lt;th&gt;Code&lt;/th&gt;    &lt;th&gt;Description&lt;/th&gt;   &lt;/tr&gt;  &lt;/thead&gt;  &lt;tbody&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;200 (OK)&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Request processed successfully. The response is different for each API, please refer to the operation&#x27;s documentation&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;400 (Bad Request)&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Syntax error. For instance, when a required field was not provided&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;401 (Unauthorized)&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;API key not provided or invalid&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;403 (Forbidden)&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;API key is valid, but the application has insufficient permissions to complete the requested operation&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;422 (Unprocessable Entity)&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;API error. The response is as defined in &lt;a href&#x3D;\&quot;#model-ErrorModel\&quot;&gt;ErrorModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;  &lt;/tbody&gt; &lt;/table&gt;  &lt;br /&gt;  &lt;h3&gt;Error Codes&lt;/h3&gt;  &lt;p&gt;Some of the error codes returned in a 422 response are provided bellow*:&lt;/p&gt;  &lt;ul&gt;  &lt;li&gt;CertificateNotFound&lt;/li&gt;  &lt;li&gt;DocumentNotFound&lt;/li&gt;  &lt;li&gt;FolderNotFound&lt;/li&gt;  &lt;li&gt;CpfMismatch&lt;/li&gt;  &lt;li&gt;CpfNotExpected&lt;/li&gt;  &lt;li&gt;InvalidFlowAction&lt;/li&gt;  &lt;li&gt;DocumentInvalidKey&lt;/li&gt; &lt;/ul&gt;  &lt;p style&#x3D;\&quot;font-size: 0.9em\&quot;&gt;  *The codes shown above are the main error codes. Nonetheless, this list is not comprehensive. New codes may be added anytime without previous warning. &lt;/p&gt;  &lt;!---------------------------------------------------------------------------------------------------------------------&gt;  &lt;br /&gt;  &lt;h2&gt;Webhooks&lt;/h2&gt;  &lt;p&gt;  It is recomended to subscribe to Webhook events &lt;strong&gt;instead&lt;/strong&gt; of polling APIs. To do so, enable webhooks and register an URL that will receive a POST request  whenever one of the events bellow occur. &lt;/p&gt; &lt;p&gt;  All requests have the format described in &lt;a href&#x3D;\&quot;#model-Webhooks.WebhookModel\&quot;&gt;Webhooks.WebhookModel&lt;/a&gt;.  The data field varies according to the webhook event type: &lt;/p&gt;   &lt;table&gt;  &lt;thead&gt;   &lt;tr&gt;    &lt;th&gt;Event type&lt;/th&gt;    &lt;th&gt;Description&lt;/th&gt;    &lt;th&gt;Payload&lt;/th&gt;   &lt;/tr&gt;  &lt;/thead&gt;  &lt;tbody&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;DocumentSigned&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Triggered when a document is signed.&lt;/td&gt;    &lt;td&gt;&lt;a href&#x3D;\&quot;#model-Webhooks.DocumentSignedModel\&quot;&gt;Webhooks.DocumentSignedModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;DocumentApproved&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Triggered when a document is approved.&lt;/td&gt;    &lt;td&gt;&lt;a href&#x3D;\&quot;#model-Webhooks.DocumentApprovedModel\&quot;&gt;Webhooks.DocumentApprovedModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;DocumentRefused&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Triggered when a document is refused.&lt;/td&gt;    &lt;td&gt;&lt;a href&#x3D;\&quot;#model-Webhooks.DocumentRefusedModel\&quot;&gt;Webhooks.DocumentRefusedModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;DocumentConcluded&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Triggered when the flow of a document is concluded.&lt;/td&gt;    &lt;td&gt;&lt;a href&#x3D;\&quot;#model-Webhooks.DocumentConcludedModel\&quot;&gt;Webhooks.DocumentConcludedModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;DocumentCanceled&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Triggered when the document is canceled.&lt;/td&gt;    &lt;td&gt;&lt;a href&#x3D;\&quot;#model-Webhooks.DocumentCanceledModel\&quot;&gt;Webhooks.DocumentCanceledModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;DocumentExpired (v1.33.0)&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Triggered when the document is expired.&lt;/td&gt;    &lt;td&gt;&lt;a href&#x3D;\&quot;#model-Webhooks.DocumentExpiredModel\&quot;&gt;Webhooks.DocumentExpiredModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;DocumentsCreated (v1.50.0)&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Triggered when one or more documents are created.&lt;/td&gt;    &lt;td&gt;&lt;a href&#x3D;\&quot;#model-Webhooks.DocumentsCreatedModel\&quot;&gt;Webhooks.DocumentsCreatedModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;   &lt;tr&gt;    &lt;td&gt;&lt;strong class&#x3D;\&quot;model-title\&quot;&gt;DocumentsDeleted (v1.78.0)&lt;/strong&gt;&lt;/td&gt;    &lt;td&gt;Triggered when one or more documents are deleted.&lt;/td&gt;    &lt;td&gt;&lt;a href&#x3D;\&quot;#model-Webhooks.DocumentsDeletedModel\&quot;&gt;Webhooks.DocumentsDeletedModel&lt;/a&gt;&lt;/td&gt;   &lt;/tr&gt;  &lt;/tbody&gt; &lt;/table&gt;  &lt;p&gt;  To register your application URL and enable Webhooks, access the integrations section in your &lt;a href&#x3D;\&quot;/private/organizations\&quot; target&#x3D;\&quot;_blank\&quot;&gt;organization&#x27;s details page&lt;/a&gt;. &lt;/p&gt;   # noqa: E501
    """
)
